' Firmware zum Testen der herstellerspezifischen Klasse (vendor) der kleinen
' USB-Bibliothek (usb_lib_vendor_v1_2.bas)
'
' Datum:  07/09/10                Version: 1.2 (16/03/13)
'
' Prozessor: AT90USB162, AT90USB1287, ATmega32u4
'
' Quarz: 8 oder 16 MHz  (siehe Zuweisungen)
'
' Informationen zur Funktionsweise:

' 1 Konfiguration mit EP0 und
' EP1: AD-Wandler Kanal 0 lesen
' EP2: PortB setzen  und Blinken D.6 ein/aus

' Achtung:  in der BASCOM-DAT-File  m32u4def.dat kontrollieren
' ob UESTA0X = $EE steht , 'wenn nicht: UESTA$ ndern -> UESTA0X
' ob UECFG0X = $EC steht , 'wenn nicht: UECFG$ ndern -> UECFG0X

' Copyright (c) 2010   Jean-Claude FELTES & Guy WEILER
'                                           weigu[at]weigu[dot]lu

' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.

' Licence: GPL-3

'Hier bitte Chip ($regfile) und Quarz ($crystal) durch Auskommentieren
'fr das entsprechende Board auswaehlen!!
'Teensy 2.0: ATmega32u4  16 MHz
'AT90USBKEY: AT90USB1287  8 MHz
'Teensy 1.0: AT90USB162  16 MHz

$regfile = "m32u4def.dat"               '_CHIP = 75
'$regfile = "usb1287.dat"                '_CHIP = 70
'$regfile = "usb162.dat"                 '_CHIP = 74
'Achtung B2.0.7.3 Fehler in Datei USB_EP statt USB_COM!!
'$regfile = "m32u2def.dat"               '_CHIP = 78
$crystal = 16000000
'$crystal = 8000000

$hwstack = 100
$swstack = 100
$framesize = 100

'Interrupts
On Usb_gen Usb_isr_general
On Usb_com Usb_isr_communication
On Oc1a Isrtc1

'Hier kann der FTDI Clone mit 1 freigeschaltet werden
Const Ftdi = 0                          'Ftdi = 0 kein Clone

Goto Init                               'Leider noetig damit globale Variablen eingebunden werden
                                         'ohne dass der Code der Isr ausgefhrt wird
$include "usb_lib_vendor_v1_2.bas"      'USB-Bibliothek einbinden
Init:


Dim Blinkflag As Bit                    'Blinken ein/aus
Dim Btmp1 As Byte                       'Zwischenregister
Dim Adcval As Word

#if _chip = 70                          'At90usb1287
Config Pind.4 = Output                  'Ausgang (LED Rot)
Config Pind.5 = Output                  'Ausgang (LED Gruen)
Config Pind.6 = Output                  'Ausgang (LED Gruen)
Config Pind.7 = Output                  'Ausgang (LED Rot)
Led1 Alias Portd.4
Led2 Alias Portd.5
Led3 Alias Portd.6
Led4 Alias Portd.7
#else
Config Pind.6 = Output                  'LEDs
Config Pinb.0 = Output
Config Pinb.1 = Output
Config Pinb.2 = Output
Config Pinb.3 = Output
Led1 Alias Portb.0
Led2 Alias Portb.1
Led3 Alias Portb.2
Led4 Alias Portb.3
#endif

Config Clockdiv = 1

'Config Timer1 = Timer
Tccr1a = 0
Tccr1b = &H0D
#if _chip = 70                          'At90usb1287
Ocr1a = 3905
#else
Ocr1a = 7811
#endif
Enable Oc1a                             'Timer Interrupt erlauben

#if _chip = 74                          'AT90usb162
Config Pinc.4 = Input
Portc.4 = 1                             'pull Up
#else
Config Adc = Free , Prescaler = Auto , Reference = Avcc
#endif


Blinkflag = 1                           'Blinken ein

Gosub Usb_init_device                   'USB-Aktivierung

'-------------------------------------------------------------------------------

Do
Ep1_cnt = 2                             'ADC liefert 2 Byte!
#if _chip = 74                          'AT90USB162 besitzt keinen A/D-Wandler
    If Pinc.4 = 0 Then                  'Es Wird Deshalb Pc4 Als Eingang eingelesen
        Ep1_buf(1) = 0
        Ep1_buf(2) = 0
    Else
        Ep1_buf(1) = Low(1023)
        Ep1_buf(2) = High(1023)
    End If
#else
    Adcval = Getadc(0)                  'ADC Wandlung starten (ADC0)
    Ep1_buf(1) = Low(adcval)
    Ep1_buf(2) = High(adcval)
#endif
    Ep1_flag = 1                        'Flag dass Daten vorhanden setzen

    If Ep2_flag = 1 Then                'neue Daten vorhanden?
         Btmp1 = Ep2_buf(1)
         Blinkflag = Btmp1.6
         Led1 = Btmp1.0
         Led2 = Btmp1.1
         Led3 = Btmp1.2
         Led4 = Btmp1.3
         Ep2_flag = 0                   'Flag loeschen
     End If

     If Blinkflag = 1 Then
         Enable Oc1a                    'Timer Interrupt erlauben
     Else
         Disable Oc1a                   'Timer Interrupt sperren
     End If
Loop


Isrtc1:
Toggle Portd.6
Return